---
title: Create a due date rule
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Security Monitoring
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create a due date rule{% #create-a-due-date-rule %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                          |
| ----------------- | ------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/security/findings/automation/due_date_rules |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/security/findings/automation/due_date_rules |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/security/findings/automation/due_date_rules      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/security/findings/automation/due_date_rules      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/security/findings/automation/due_date_rules  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/security/findings/automation/due_date_rules |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/security/findings/automation/due_date_rules     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/security/findings/automation/due_date_rules |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/security/findings/automation/due_date_rules |

### Overview

Create a new due date rule for the current organization. This endpoint requires the `security_pipelines_write` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field          | Field                                   | Type     | Description                                                                                                                                                                                                                                                                                  |
| --------------------- | --------------------------------------- | -------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                       | data [*required*]                  | object   | The data object for a due date rule create or update request.                                                                                                                                                                                                                                |
| data                  | attributes [*required*]            | object   | Attributes for creating or updating a due date rule.                                                                                                                                                                                                                                         |
| attributes            | action [*required*]                | object   | The action to take when the due date rule matches a finding.                                                                                                                                                                                                                                 |
| action                | due_days_per_severity [*required*] | [object] | A list of severity-to-due-date mappings. Each severity may appear at most once.                                                                                                                                                                                                              |
| due_days_per_severity | due_in_days [*required*]           | int64    | The number of days from the reference point until the finding is due.                                                                                                                                                                                                                        |
| due_days_per_severity | severity [*required*]              | enum     | A severity level used to configure due date thresholds. Allowed enum values: `critical,high,medium,low,info,none,unknown`                                                                                                                                                                    |
| action                | due_from [*required*]              | enum     | The reference point from which the due date is calculated. When `fix_available` is selected but not applicable to the finding type, `first_seen` is used instead. Allowed enum values: `first_seen,fix_available`                                                                            |
| action                | reason_description                      | string   | An optional description providing more context for the due date assignment.                                                                                                                                                                                                                  |
| attributes            | enabled                                 | boolean  | Whether the due date rule is enabled.                                                                                                                                                                                                                                                        |
| attributes            | name [*required*]                  | string   | The name of the due date rule.                                                                                                                                                                                                                                                               |
| attributes            | rule [*required*]                  | object   | Defines the scope of findings to which the automation rule applies.                                                                                                                                                                                                                          |
| rule                  | finding_types [*required*]         | [string] | The list of security finding types that the automation rule applies to.                                                                                                                                                                                                                      |
| rule                  | query                                   | string   | A search query to further filter the findings matched by this rule. The `@workflow.*` namespace and `@status` fields are not permitted. For a reference of available fields, see the [Security Findings schema documentation](https://docs.datadoghq.com/security/guide/findings-schema.md). |
| data                  | type [*required*]                  | enum     | The JSON:API type for due date rules. Allowed enum values: `due_date_rules`                                                                                                                                                                                                                  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "action": {
        "due_days_per_severity": [
          {
            "due_in_days": 7,
            "severity": "critical"
          }
        ],
        "due_from": "first_seen"
      },
      "enabled": true,
      "name": "Example-Security-Monitoring",
      "rule": {
        "finding_types": [
          "misconfiguration"
        ],
        "query": "env:staging"
      }
    },
    "type": "due_date_rules"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Successfully created the due date rule
{% tab title="Model" %}
A single due date rule response.

| Parent field          | Field                                   | Type     | Description                                                                                                                                                                                                                                                                                  |
| --------------------- | --------------------------------------- | -------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                       | data [*required*]                  | object   | The data object for a due date rule returned by the API.                                                                                                                                                                                                                                     |
| data                  | attributes [*required*]            | object   | Attributes of a due date rule returned by the API.                                                                                                                                                                                                                                           |
| attributes            | action [*required*]                | object   | The action to take when the due date rule matches a finding.                                                                                                                                                                                                                                 |
| action                | due_days_per_severity [*required*] | [object] | A list of severity-to-due-date mappings. Each severity may appear at most once.                                                                                                                                                                                                              |
| due_days_per_severity | due_in_days [*required*]           | int64    | The number of days from the reference point until the finding is due.                                                                                                                                                                                                                        |
| due_days_per_severity | severity [*required*]              | enum     | A severity level used to configure due date thresholds. Allowed enum values: `critical,high,medium,low,info,none,unknown`                                                                                                                                                                    |
| action                | due_from [*required*]              | enum     | The reference point from which the due date is calculated. When `fix_available` is selected but not applicable to the finding type, `first_seen` is used instead. Allowed enum values: `first_seen,fix_available`                                                                            |
| action                | reason_description                      | string   | An optional description providing more context for the due date assignment.                                                                                                                                                                                                                  |
| attributes            | created_at [*required*]            | int64    | The Unix timestamp in milliseconds when the rule was created.                                                                                                                                                                                                                                |
| attributes            | created_by [*required*]            | object   | The user or Datadog system who created the rule.                                                                                                                                                                                                                                             |
| created_by            | id [*required*]                    | string   | The actor's identifier (a user UUID or a system identifier).                                                                                                                                                                                                                                 |
| created_by            | name [*required*]                  | string   | The name of the actor.                                                                                                                                                                                                                                                                       |
| created_by            | type [*required*]                  | enum     | Whether the actor is a user or the Datadog system. Allowed enum values: `user,system`                                                                                                                                                                                                        |
| attributes            | enabled [*required*]               | boolean  | Whether the due date rule is enabled.                                                                                                                                                                                                                                                        |
| attributes            | modified_at [*required*]           | int64    | The Unix timestamp in milliseconds when the rule was last modified.                                                                                                                                                                                                                          |
| attributes            | modified_by [*required*]           | object   | The user or Datadog system who last modified the rule.                                                                                                                                                                                                                                       |
| modified_by           | id [*required*]                    | string   | The actor's identifier (a user UUID or a system identifier).                                                                                                                                                                                                                                 |
| modified_by           | name [*required*]                  | string   | The name of the actor.                                                                                                                                                                                                                                                                       |
| modified_by           | type [*required*]                  | enum     | Whether the actor is a user or the Datadog system. Allowed enum values: `user,system`                                                                                                                                                                                                        |
| attributes            | name [*required*]                  | string   | The name of the due date rule.                                                                                                                                                                                                                                                               |
| attributes            | rule [*required*]                  | object   | Defines the scope of findings to which the automation rule applies.                                                                                                                                                                                                                          |
| rule                  | finding_types [*required*]         | [string] | The list of security finding types that the automation rule applies to.                                                                                                                                                                                                                      |
| rule                  | query                                   | string   | A search query to further filter the findings matched by this rule. The `@workflow.*` namespace and `@status` fields are not permitted. For a reference of available fields, see the [Security Findings schema documentation](https://docs.datadoghq.com/security/guide/findings-schema.md). |
| data                  | id [*required*]                    | uuid     | The ID of the due date rule.                                                                                                                                                                                                                                                                 |
| data                  | type [*required*]                  | enum     | The JSON:API type for due date rules. Allowed enum values: `due_date_rules`                                                                                                                                                                                                                  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "action": {
        "due_days_per_severity": [
          {
            "due_in_days": 7,
            "severity": "critical"
          }
        ],
        "due_from": "first_seen",
        "reason_description": "Applied for production findings only"
      },
      "created_at": 1722439510282,
      "created_by": {
        "id": "00000000-0000-0000-0000-000000000000",
        "name": "Jane Doe",
        "type": "user"
      },
      "enabled": true,
      "modified_at": 1722439510282,
      "modified_by": {
        "id": "00000000-0000-0000-0000-000000000000",
        "name": "Jane Doe",
        "type": "user"
      },
      "name": "Critical findings due in 7 days",
      "rule": {
        "finding_types": [
          "misconfiguration"
        ],
        "query": "env:prod team:platform"
      }
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "type": "due_date_rules"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="422" %}
Unprocessable Entity
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/security/findings/automation/due_date_rules" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "action": {
        "due_days_per_severity": [
          {
            "due_in_days": 7,
            "severity": "critical"
          },
          {
            "due_in_days": 30,
            "severity": "high"
          }
        ],
        "due_from": "first_seen"
      },
      "enabled": true,
      "name": "Critical findings due in 7 days",
      "rule": {
        "finding_types": [
          "misconfiguration"
        ],
        "query": "env:prod"
      }
    },
    "type": "due_date_rules"
  }
}
EOF 
                        
##### 

```go
// Create a due date rule returns "Successfully created the due date rule" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.DueDateRuleCreateRequest{
		Data: datadogV2.DueDateRuleDataCreate{
			Attributes: datadogV2.DueDateRuleAttributesCreate{
				Action: datadogV2.DueDateRuleAction{
					DueDaysPerSeverity: []datadogV2.DueDatePerSeverityItem{
						{
							DueInDays: 7,
							Severity:  datadogV2.DUEDATESEVERITY_CRITICAL,
						},
					},
					DueFrom: datadogV2.DUEDATEFROM_FIRST_SEEN,
				},
				Enabled: datadog.PtrBool(true),
				Name:    "Example-Security-Monitoring",
				Rule: datadogV2.AutomationRuleScope{
					FindingTypes: []datadogV2.SecurityFindingType{
						datadogV2.SECURITYFINDINGTYPE_MISCONFIGURATION,
					},
					Query: datadog.PtrString("env:staging"),
				},
			},
			Type: datadogV2.DUEDATERULETYPE_DUE_DATE_RULES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateSecurityFindingsAutomationDueDateRule", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSecurityMonitoringApi(apiClient)
	resp, r, err := api.CreateSecurityFindingsAutomationDueDateRule(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SecurityMonitoringApi.CreateSecurityFindingsAutomationDueDateRule`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SecurityMonitoringApi.CreateSecurityFindingsAutomationDueDateRule`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create a due date rule returns "Successfully created the due date rule" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SecurityMonitoringApi;
import com.datadog.api.client.v2.model.AutomationRuleScope;
import com.datadog.api.client.v2.model.DueDateFrom;
import com.datadog.api.client.v2.model.DueDatePerSeverityItem;
import com.datadog.api.client.v2.model.DueDateRuleAction;
import com.datadog.api.client.v2.model.DueDateRuleAttributesCreate;
import com.datadog.api.client.v2.model.DueDateRuleCreateRequest;
import com.datadog.api.client.v2.model.DueDateRuleDataCreate;
import com.datadog.api.client.v2.model.DueDateRuleResponse;
import com.datadog.api.client.v2.model.DueDateRuleType;
import com.datadog.api.client.v2.model.DueDateSeverity;
import com.datadog.api.client.v2.model.SecurityFindingType;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled(
        "v2.createSecurityFindingsAutomationDueDateRule", true);
    SecurityMonitoringApi apiInstance = new SecurityMonitoringApi(defaultClient);

    DueDateRuleCreateRequest body =
        new DueDateRuleCreateRequest()
            .data(
                new DueDateRuleDataCreate()
                    .attributes(
                        new DueDateRuleAttributesCreate()
                            .action(
                                new DueDateRuleAction()
                                    .dueDaysPerSeverity(
                                        Collections.singletonList(
                                            new DueDatePerSeverityItem()
                                                .dueInDays(7L)
                                                .severity(DueDateSeverity.CRITICAL)))
                                    .dueFrom(DueDateFrom.FIRST_SEEN))
                            .enabled(true)
                            .name("Example-Security-Monitoring")
                            .rule(
                                new AutomationRuleScope()
                                    .findingTypes(
                                        Collections.singletonList(
                                            SecurityFindingType.MISCONFIGURATION))
                                    .query("env:staging")))
                    .type(DueDateRuleType.DUE_DATE_RULES));

    try {
      DueDateRuleResponse result = apiInstance.createSecurityFindingsAutomationDueDateRule(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling"
              + " SecurityMonitoringApi#createSecurityFindingsAutomationDueDateRule");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create a due date rule returns "Successfully created the due date rule" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.security_monitoring_api import SecurityMonitoringApi
from datadog_api_client.v2.model.automation_rule_scope import AutomationRuleScope
from datadog_api_client.v2.model.due_date_from import DueDateFrom
from datadog_api_client.v2.model.due_date_per_severity_item import DueDatePerSeverityItem
from datadog_api_client.v2.model.due_date_rule_action import DueDateRuleAction
from datadog_api_client.v2.model.due_date_rule_attributes_create import DueDateRuleAttributesCreate
from datadog_api_client.v2.model.due_date_rule_create_request import DueDateRuleCreateRequest
from datadog_api_client.v2.model.due_date_rule_data_create import DueDateRuleDataCreate
from datadog_api_client.v2.model.due_date_rule_type import DueDateRuleType
from datadog_api_client.v2.model.due_date_severity import DueDateSeverity
from datadog_api_client.v2.model.security_finding_type import SecurityFindingType

body = DueDateRuleCreateRequest(
    data=DueDateRuleDataCreate(
        attributes=DueDateRuleAttributesCreate(
            action=DueDateRuleAction(
                due_days_per_severity=[
                    DueDatePerSeverityItem(
                        due_in_days=7,
                        severity=DueDateSeverity.CRITICAL,
                    ),
                ],
                due_from=DueDateFrom.FIRST_SEEN,
            ),
            enabled=True,
            name="Example-Security-Monitoring",
            rule=AutomationRuleScope(
                finding_types=[
                    SecurityFindingType.MISCONFIGURATION,
                ],
                query="env:staging",
            ),
        ),
        type=DueDateRuleType.DUE_DATE_RULES,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_security_findings_automation_due_date_rule"] = True
with ApiClient(configuration) as api_client:
    api_instance = SecurityMonitoringApi(api_client)
    response = api_instance.create_security_findings_automation_due_date_rule(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create a due date rule returns "Successfully created the due date rule" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_security_findings_automation_due_date_rule".to_sym] = true
end
api_instance = DatadogAPIClient::V2::SecurityMonitoringAPI.new

body = DatadogAPIClient::V2::DueDateRuleCreateRequest.new({
  data: DatadogAPIClient::V2::DueDateRuleDataCreate.new({
    attributes: DatadogAPIClient::V2::DueDateRuleAttributesCreate.new({
      action: DatadogAPIClient::V2::DueDateRuleAction.new({
        due_days_per_severity: [
          DatadogAPIClient::V2::DueDatePerSeverityItem.new({
            due_in_days: 7,
            severity: DatadogAPIClient::V2::DueDateSeverity::CRITICAL,
          }),
        ],
        due_from: DatadogAPIClient::V2::DueDateFrom::FIRST_SEEN,
      }),
      enabled: true,
      name: "Example-Security-Monitoring",
      rule: DatadogAPIClient::V2::AutomationRuleScope.new({
        finding_types: [
          DatadogAPIClient::V2::SecurityFindingType::MISCONFIGURATION,
        ],
        query: "env:staging",
      }),
    }),
    type: DatadogAPIClient::V2::DueDateRuleType::DUE_DATE_RULES,
  }),
})
p api_instance.create_security_findings_automation_due_date_rule(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create a due date rule returns "Successfully created the due date rule" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;
use datadog_api_client::datadogV2::model::AutomationRuleScope;
use datadog_api_client::datadogV2::model::DueDateFrom;
use datadog_api_client::datadogV2::model::DueDatePerSeverityItem;
use datadog_api_client::datadogV2::model::DueDateRuleAction;
use datadog_api_client::datadogV2::model::DueDateRuleAttributesCreate;
use datadog_api_client::datadogV2::model::DueDateRuleCreateRequest;
use datadog_api_client::datadogV2::model::DueDateRuleDataCreate;
use datadog_api_client::datadogV2::model::DueDateRuleType;
use datadog_api_client::datadogV2::model::DueDateSeverity;
use datadog_api_client::datadogV2::model::SecurityFindingType;

#[tokio::main]
async fn main() {
    let body = DueDateRuleCreateRequest::new(DueDateRuleDataCreate::new(
        DueDateRuleAttributesCreate::new(
            DueDateRuleAction::new(
                vec![DueDatePerSeverityItem::new(7, DueDateSeverity::CRITICAL)],
                DueDateFrom::FIRST_SEEN,
            ),
            "Example-Security-Monitoring".to_string(),
            AutomationRuleScope::new(vec![SecurityFindingType::MISCONFIGURATION])
                .query("env:staging".to_string()),
        )
        .enabled(true),
        DueDateRuleType::DUE_DATE_RULES,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration
        .set_unstable_operation_enabled("v2.CreateSecurityFindingsAutomationDueDateRule", true);
    let api = SecurityMonitoringAPI::with_config(configuration);
    let resp = api
        .create_security_findings_automation_due_date_rule(body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create a due date rule returns "Successfully created the due date rule" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations[
  "v2.createSecurityFindingsAutomationDueDateRule"
] = true;
const apiInstance = new v2.SecurityMonitoringApi(configuration);

const params: v2.SecurityMonitoringApiCreateSecurityFindingsAutomationDueDateRuleRequest =
  {
    body: {
      data: {
        attributes: {
          action: {
            dueDaysPerSeverity: [
              {
                dueInDays: 7,
                severity: "critical",
              },
            ],
            dueFrom: "first_seen",
          },
          enabled: true,
          name: "Example-Security-Monitoring",
          rule: {
            findingTypes: ["misconfiguration"],
            query: "env:staging",
          },
        },
        type: "due_date_rules",
      },
    },
  };

apiInstance
  .createSecurityFindingsAutomationDueDateRule(params)
  .then((data: v2.DueDateRuleResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
